<template>
    <nav>
        <div class="app-title">
            <RouterLink to="/">Vue + TS + Tailwind CSS Test</RouterLink>
        </div>
        <div class="items">
            <ul>
                <li v-for="link in links">
                    <RouterLink :to="link.path">{{ link.title }}</RouterLink>
                </li>
            </ul>
        </div>
    </nav>
</template>

<script setup lang="ts">

import { computed } from 'vue';
import { RouteLocationRaw, RouterLink, useRouter } from 'vue-router';

interface DisplayRoute {
    path: RouteLocationRaw;
    title: String;
}

defineProps({
    // @ts-ignore
    ...RouterLink.props,
    title: String,
});

const router = useRouter();

const links = computed(() =>
    router.getRoutes().filter(r => r.path !== '/').map(r => ({
        path: r.path,
        title: r.meta.title,
    } as DisplayRoute))
);

</script>

<style scoped>
a {
    @apply no-underline text-slate-800 dark:text-slate-100;
    @apply hover:text-slate-700 dark:hover:text-slate-200 hover:no-underline;
}

nav {
    @apply flex justify-start items-center min-h-16 min-w-full;
    @apply px-3 py-4;
    @apply bg-indigo-300 dark:bg-indigo-800 border-b-indigo-800 dark:border-b-indigo-300;
}

.app-title {
    @apply ml-2;
    @apply text-2xl text-slate-800 dark:text-slate-100;
    @apply font-bold;
}

.items {
    @apply flex flex-1 justify-between items-center;
    @apply ml-6 mr-3;
    @apply font-normal text-slate-800 dark:text-slate-100;
}

ul {
    @apply flex justify-start items-center gap-2;
    @apply list-none;
}

li>a {
    @apply p-3 rounded text-slate-800 dark:text-slate-100 border border-indigo-800;
    @apply hover:border hover:border-indigo-600 hover:bg-indigo-600 hover:text-slate-100;
    @apply active:border-indigo-500 active:bg-indigo-700;
    @apply transition-colors duration-200;
}
</style>
